/*
 *  Cylinder.h
 *  Assignment3
 *
 *  Created by Zach Gildersleeve on 2/6/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef CYLINDER_H
#define CYLINDER_H

#include "Primitive.h"
#include "Ray.h"

class Cylinder : public Primitive {
	public:
		Cylinder(Material *mat, const Vector &newDirection, const Point &newCenter, double newRadius);
	
		virtual ~Cylinder() {}
	
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		virtual void normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const;
	
	private:
		Vector direction;
		Point center;
		double radius;

};

#endif