/*
 *  Plane.h
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/31/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef PLANE_H
#define PLANE_H

#include "Primitive.h"
#include "Vector.h"
#include "Ray.h"
#include "HitRecord.h"
#include "Object.h"
#include "Point.h"

//class Vector;
class Point;

class Plane : public Primitive {

	public:
		Plane(Material *newMaterial, const Vector &newNormal, const Point &newCenter);
		
		virtual ~Plane();
		
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		virtual void normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const;
	
	private:
		Vector normalVector;
		Point center;
		double d;
};



#endif